import _createClass from "@babel/runtime/helpers/createClass";
import { TransformStage } from '@alilc/lowcode-types';
import { propSymbol } from './symbols';
import Node from './node';

var Prop = /*#__PURE__*/function () {
  function Prop(prop) {
    this[propSymbol] = void 0;
    this[propSymbol] = prop;
  }

  Prop.create = function create(prop) {
    if (!prop) return null;
    return new Prop(prop);
  }
  /**
   * id
   */
  ;

  var _proto = Prop.prototype;

  /**
   * 设置值
   * @param val
   */
  _proto.setValue = function setValue(val) {
    this[propSymbol].setValue(val);
  }
  /**
   * 获取值
   * @returns
   */
  ;

  _proto.getValue = function getValue() {
    return this[propSymbol].getValue();
  }
  /**
   * 导出值
   * @param stage
   * @returns
   */
  ;

  _proto.exportSchema = function exportSchema(stage) {
    if (stage === void 0) {
      stage = TransformStage.Render;
    }

    return this[propSymbol]["export"](stage);
  };

  _createClass(Prop, [{
    key: "id",
    get: function get() {
      return this[propSymbol].id;
    }
    /**
     * key 值
     */

  }, {
    key: "key",
    get: function get() {
      return this[propSymbol].key;
    }
    /**
     * 返回当前 prop 的路径
     */

  }, {
    key: "path",
    get: function get() {
      return this[propSymbol].path;
    }
    /**
     * 返回所属的节点实例
     */

  }, {
    key: "node",
    get: function get() {
      return Node.create(this[propSymbol].getNode());
    }
  }]);

  return Prop;
}();

export { Prop as default };