import _createClass from "@babel/runtime/helpers/createClass";
import { settingTopEntrySymbol } from './symbols';
import Node from './node';

var SettingTopEntry = /*#__PURE__*/function () {
  function SettingTopEntry(prop) {
    this[settingTopEntrySymbol] = void 0;
    this[settingTopEntrySymbol] = prop;
  }

  SettingTopEntry.create = function create(prop) {
    return new SettingTopEntry(prop);
  }
  /**
   * 返回所属的节点实例
   */
  ;

  var _proto = SettingTopEntry.prototype;

  /**
   * @deprecated use .node instead
   */
  _proto.getNode = function getNode() {
    return this.node;
  }
  /**
   * 获取指定 propName 的值
   * @param propName
   * @returns
   */
  ;

  _proto.getPropValue = function getPropValue(propName) {
    return this[settingTopEntrySymbol].getPropValue(propName);
  }
  /**
   * 设置指定 propName 的值
   * @param propName
   * @param value
   */
  ;

  _proto.setPropValue = function setPropValue(propName, value) {
    this[settingTopEntrySymbol].setPropValue(propName, value);
  };

  _createClass(SettingTopEntry, [{
    key: "node",
    get: function get() {
      return Node.create(this[settingTopEntrySymbol].getNode());
    }
  }]);

  return SettingTopEntry;
}();

export { SettingTopEntry as default };