"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _symbols = require("./symbols");

var Dragon = /*#__PURE__*/function () {
  function Dragon(dragon) {
    this[_symbols.dragonSymbol] = void 0;
    this[_symbols.dragonSymbol] = dragon;
  }

  Dragon.create = function create(dragon) {
    if (!dragon) return null;
    return new Dragon(dragon);
  }
  /**
   * 绑定 dragstart 事件
   * @param func
   * @returns
   */
  ;

  var _proto = Dragon.prototype;

  _proto.onDragstart = function onDragstart(func) {
    // TODO: 补充必要参数
    return this[_symbols.dragonSymbol].onDragstart(function () {
      return func();
    });
  }
  /**
   * 绑定 drag 事件
   * @param func
   * @returns
   */
  ;

  _proto.onDrag = function onDrag(func) {
    // TODO: 补充必要参数
    return this[_symbols.dragonSymbol].onDrag(function () {
      return func();
    });
  }
  /**
   * 绑定 dragend 事件
   * @param func
   * @returns
   */
  ;

  _proto.onDragend = function onDragend(func) {
    // TODO: 补充必要参数
    return this[_symbols.dragonSymbol].onDragend(function () {
      return func();
    });
  }
  /**
   * 设置拖拽监听的区域 shell，以及自定义拖拽转换函数 boost
   * @param shell 拖拽监听的区域
   * @param boost 拖拽转换函数
   */
  ;

  _proto.from = function from(shell, boost) {
    return this[_symbols.dragonSymbol].from(shell, boost);
  };

  return Dragon;
}();

exports["default"] = Dragon;