import _createClass from "@babel/runtime/helpers/createClass";
import { designerSymbol } from './symbols';
import DropLocation from './drop-location';

var Canvas = /*#__PURE__*/function () {
  function Canvas(designer) {
    this[designerSymbol] = void 0;
    this[designerSymbol] = designer;
  }

  Canvas.create = function create(designer) {
    if (!designer) return null;
    return new Canvas(designer);
  };

  _createClass(Canvas, [{
    key: "dropLocation",
    get: function get() {
      return DropLocation.create(this[designerSymbol].dropLocation || null);
    }
  }]);

  return Canvas;
}();

export { Canvas as default };