import _createClass from "@babel/runtime/helpers/createClass";
import Node from './node';
import { documentSymbol, selectionSymbol } from './symbols';

var Selection = /*#__PURE__*/function () {
  function Selection(document) {
    this[documentSymbol] = void 0;
    this[selectionSymbol] = void 0;
    this[documentSymbol] = document;
    this[selectionSymbol] = document.selection;
  }
  /**
   * 返回选中的节点 id
   */


  var _proto = Selection.prototype;

  /**
   * 选中指定节点（覆盖方式）
   * @param id
   */
  _proto.select = function select(id) {
    this[selectionSymbol].select(id);
  }
  /**
   * 批量选中指定节点们
   * @param ids
   */
  ;

  _proto.selectAll = function selectAll(ids) {
    this[selectionSymbol].selectAll(ids);
  }
  /**
   * 移除选中的指定节点
   * @param id
   */
  ;

  _proto.remove = function remove(id) {
    this[selectionSymbol].remove(id);
  }
  /**
   * 清除所有选中节点
   */
  ;

  _proto.clear = function clear() {
    this[selectionSymbol].clear();
  }
  /**
   * 判断是否选中了指定节点
   * @param id
   * @returns
   */
  ;

  _proto.has = function has(id) {
    return this[selectionSymbol].has(id);
  }
  /**
   * 选中指定节点（增量方式）
   * @param id
   */
  ;

  _proto.add = function add(id) {
    this[selectionSymbol].add(id);
  }
  /**
   * 获取选中的节点实例
   * @returns
   */
  ;

  _proto.getNodes = function getNodes() {
    return this[selectionSymbol].getNodes().map(function (node) {
      return Node.create(node);
    });
  };

  _createClass(Selection, [{
    key: "selected",
    get: function get() {
      return this[selectionSymbol].selected;
    }
  }]);

  return Selection;
}();

export { Selection as default };