import _createClass from "@babel/runtime/helpers/createClass";
import { simulatorHostSymbol } from './symbols';

var SimulatorHost = /*#__PURE__*/function () {
  function SimulatorHost(simulator) {
    this[simulatorHostSymbol] = void 0;
    this[simulatorHostSymbol] = simulator;
  }

  SimulatorHost.create = function create(host) {
    if (!host) return null;
    return new SimulatorHost(host);
  }
  /**
   * 获取 contentWindow
   */
  ;

  var _proto = SimulatorHost.prototype;

  /**
   * 设置 host 配置值
   * @param key
   * @param value
   */
  _proto.set = function set(key, value) {
    this[simulatorHostSymbol].set(key, value);
  }
  /**
   * 获取 host 配置值
   * @param key
   * @returns
   */
  ;

  _proto.get = function get(key) {
    return this[simulatorHostSymbol].get(key);
  };

  _createClass(SimulatorHost, [{
    key: "contentWindow",
    get: function get() {
      return this[simulatorHostSymbol].contentWindow;
    }
    /**
     * 获取 contentDocument
     */

  }, {
    key: "contentDocument",
    get: function get() {
      return this[simulatorHostSymbol].contentDocument;
    }
  }]);

  return SimulatorHost;
}();

export { SimulatorHost as default };