"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _symbols = require("./symbols");

var _dropLocation = _interopRequireDefault(require("./drop-location"));

var Canvas = /*#__PURE__*/function () {
  function Canvas(designer) {
    this[_symbols.designerSymbol] = void 0;
    this[_symbols.designerSymbol] = designer;
  }

  Canvas.create = function create(designer) {
    if (!designer) return null;
    return new Canvas(designer);
  };

  (0, _createClass2["default"])(Canvas, [{
    key: "dropLocation",
    get: function get() {
      return _dropLocation["default"].create(this[_symbols.designerSymbol].dropLocation || null);
    }
  }]);
  return Canvas;
}();

exports["default"] = Canvas;