"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
var _exportNames = {
  Detecting: true,
  DocumentModel: true,
  Event: true,
  getEvent: true,
  History: true,
  Material: true,
  Node: true,
  Project: true,
  Prop: true,
  Selection: true,
  Setters: true,
  Hotkey: true,
  Skeleton: true,
  Dragon: true,
  SettingPropEntry: true
};

var _detecting = _interopRequireDefault(require("./detecting"));

exports.Detecting = _detecting["default"];

var _documentModel = _interopRequireDefault(require("./document-model"));

exports.DocumentModel = _documentModel["default"];

var _event = _interopRequireWildcard(require("./event"));

exports.Event = _event["default"];
exports.getEvent = _event.getEvent;

var _history = _interopRequireDefault(require("./history"));

exports.History = _history["default"];

var _material = _interopRequireDefault(require("./material"));

exports.Material = _material["default"];

var _node = _interopRequireDefault(require("./node"));

exports.Node = _node["default"];

var _project = _interopRequireDefault(require("./project"));

exports.Project = _project["default"];

var _prop = _interopRequireDefault(require("./prop"));

exports.Prop = _prop["default"];

var _selection = _interopRequireDefault(require("./selection"));

exports.Selection = _selection["default"];

var _setters = _interopRequireDefault(require("./setters"));

exports.Setters = _setters["default"];

var _hotkey = _interopRequireDefault(require("./hotkey"));

exports.Hotkey = _hotkey["default"];

var _skeleton = _interopRequireDefault(require("./skeleton"));

exports.Skeleton = _skeleton["default"];

var _dragon = _interopRequireDefault(require("./dragon"));

exports.Dragon = _dragon["default"];

var _settingPropEntry = _interopRequireDefault(require("./setting-prop-entry"));

exports.SettingPropEntry = _settingPropEntry["default"];

var _symbols = require("./symbols");

Object.keys(_symbols).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _symbols[key]) return;
  exports[key] = _symbols[key];
});

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }